Attribute VB_Name = "modFileItem"
' modFileItem - Process menu File Items
' 1998/03/29 Copyright  1998, Management MarketPlace, Inc.
' 1998/03/29 Written by Larry Rebich [650-737-0870]
    
    Option Explicit
    DefLng A-Z
    
    ' File Menu item constants
    Const mciFileNew        As Integer = 0
    Const mciFileOpen       As Integer = 1
    Const mciFileSaveAs     As Integer = 2
    Const mciFileDelete     As Integer = 3
    Const mciFileSepA       As Integer = 4
    Const mciFileExport     As Integer = 5
    Const mciFileImport     As Integer = 6
    ' File Menu item captions
    Const mcsFileNew        As String = "&New "
    Const mcsFileOpen       As String = "&Open "
    Const mcsFileSaveAs     As String = "Save &As "
    Const mcsFileDelete     As String = "&Delete "
    Const mcsFileSepA       As String = "-"
    Const mcsFileExport     As String = "&Export..."
    Const mcsFileImport     As String = "&Import..."
    

Public Sub mnuFileItemClick(mdi As MDIForm, Index As Integer)
    Select Case Index
        Case mciFileNew
            DoFileNew mdi
        Case mciFileOpen
            DoFileOpen mdi
        Case mciFileSaveAs
            DoFileSaveAs mdi
        Case mciFileDelete
            DoFileDelete mdi
        Case mciFileExport
            DoFileExport mdi
        Case mciFileImport
            DoFileImport mdi
    End Select
End Sub

Public Sub BuildFileItems(mdi As MDIForm)
    Const csDB = " Database..."
    Dim i As Integer
    With mdi
        For i = 1 To mciFileImport
            Load .mnuFileItem(i)
            .mnuFileItem(i).Visible = True
        Next
        .mnuFileItem(mciFileNew).Caption = mcsFileNew & gcsQuikApps & csDB
        .mnuFileItem(mciFileOpen).Caption = mcsFileOpen & gcsQuikApps & csDB
        .mnuFileItem(mciFileSaveAs).Caption = mcsFileSaveAs & gcsQuikApps & csDB
        .mnuFileItem(mciFileDelete).Caption = mcsFileDelete & gcsQuikApps & csDB
        .mnuFileItem(mciFileSepA).Caption = mcsFileSepA
        .mnuFileItem(mciFileExport).Caption = mcsFileExport
        .mnuFileItem(mciFileImport).Caption = mcsFileImport
        ' Temporary
        .mnuFileItem(mciFileSaveAs).Visible = False
'        .mnuFileItem(mciFileDelete).Visible = False
        .mnuFileItem(mciFileSepA).Visible = False
        .mnuFileItem(mciFileExport).Visible = False
        .mnuFileItem(mciFileImport).Visible = False
    End With
End Sub

Private Sub DoFileSaveAs(mdi As MDIForm)

End Sub

Private Sub DoFileExport(mdi As MDIForm)

End Sub

Private Sub DoFileImport(mdi As MDIForm)

End Sub

Private Sub DoFileNew(mdi As MDIForm)
    Dim cdl As New CDialog
    
    With cdl
        .Flags = cdlOFNOverwritePrompt Or cdlOFNExplorer Or cdlOFNHideReadOnly
        .Filter = gcsQuikApps & " Database [*" & gcsDBSuffixV2 & "]|*" & gcsDBSuffixV2
        .DefaultExt = "*" & gcsDBSuffixV2
        .DialogTitle = " Enter a New " & gcsQuikApplications & " Database Name"
        .CancelError = True
        .ShowSave
        If Not .Cancelled Then
            OpenANewDB mdi, .Filename
        End If
    End With
    Set cdl = Nothing
End Sub

Private Sub DoFileOpen(mdi As MDIForm)
    Dim cdl As New CDialog
    Dim db  As Database
    
'    On Error GoTo DoFileOpenEH
    With cdl
        .Flags = cdlOFNExplorer Or cdlOFNHideReadOnly
        .Filter = gcsQuikApps & " Database [*" & gcsDBSuffixV2 & "]|*" & gcsDBSuffixV2 & "|Access Database [*.mdb]|*.mdb" & "|Any File [*.*]|*.*"
        .DefaultExt = "*" & gcsDBSuffixV2
        .DialogTitle = " Open a " & gcsQuikApplications & " Database"
        .CancelError = True
DoFileOpenRetry:
        .ShowOpen
        If Not .Cancelled Then
            If Not IsModelDB(.Filename) Then
                If Dir$(cdl.Filename) <> "" Then        'open it
                    If OpenDB(db, cdl.Filename) Then    'one of ours
                        CloseDB db
                        OpenAnotherDB mdi, .Filename, False
                    Else
                        If Not CloseDB(db) Then
                            MessageNotQuikAppsDB .Filename, False
                        End If
                    End If
                End If
            Else
                MessageModelDB .Filename
                .Filename = ""
                GoTo DoFileOpenRetry
            End If
        End If
    End With
DoFileOpenEH:
    Set cdl = Nothing
    Set db = Nothing
End Sub

Private Function IsModelDB(sFile As String) As Boolean
    Dim sTemp1 As String
    Dim sTemp2 As String
    sTemp1 = LCase$(sFile)
    sTemp2 = LCase$(gsModelDatabaseNameWithPath)
    If InStr(sTemp1, sTemp2) > 0 Then
        IsModelDB = True
    End If
End Function

Private Sub MessageModelDB(sFile As String)
'-------------------------------------------------------------------------------
' 1998/03/31 7:52:37 PM, Code generated by TBMsgBox 5.06, a product of The Bridge, Inc.
    Dim sMBVB_Msg As String         'The Message is passed in this variable
    Dim sMBVB_Title As String       'The Title is passed in this variable
    Dim lMBVB_Type As Long          'Icon information, number of buttons, etc. is passed in this long integer
    sMBVB_Msg = "File '" & sFile & "' is the " & gcsQuikApplications & " model database.  " & vbCr
    sMBVB_Msg = sMBVB_Msg & vbCr
    sMBVB_Msg = sMBVB_Msg & "It is used to create new " & gcsQuikApplications & " databases. "
    sMBVB_Msg = sMBVB_Msg & "It should not be changed." & vbCr
    sMBVB_Msg = sMBVB_Msg & vbCr
    sMBVB_Msg = sMBVB_Msg & "Please select another database."
    sMBVB_Title = " " & gcsQuikApplications & " Model Database"
    lMBVB_Type = vbExclamation
    lMBVB_Type = lMBVB_Type

    MsgBox sMBVB_Msg, lMBVB_Type, sMBVB_Title
'-------------------------------------------------------------------------------
End Sub

Private Sub DoFileDelete(mdi As MDIForm)
    Dim cdl     As New CDialog
    Dim db      As Database
    Dim iHow    As Integer
    
    
'    MsgBox "Under Construction!!", vbInformation, " Delete Database"
'    Exit Sub
    
    On Error GoTo DoFileDeleteEH
    With cdl
        .Flags = cdlOFNExplorer Or cdlOFNHideReadOnly
        .Filter = gcsQuikApps & " Database [*" & gcsDBSuffixV2 & "]|*" & gcsDBSuffixV2 & "|Access Database [*.mdb]|*.mdb"
        .DefaultExt = "*" & gcsDBSuffixV2
        .DialogTitle = " Select a " & gcsQuikApplications & " Database to Delete"
        .CancelError = True
DoFileDeleteRetry:
        .ShowOpen
        If Not .Cancelled Then
            If Not IsModelDB(.Filename) Then
                If Dir$(cdl.Filename) <> "" Then            'open it
                    If OpenDB(db, .Filename, , True) Then   'one of ours
                        CloseDB db
                        If MessageOKToDelete(.Filename) Then
                            iHow = DoFileDeleteNow(.Filename)
                            If iHow = 2 Then
                                End
                            End If
                        End If
                    Else
                        If Not CloseDB(db) Then
                            MessageNotQuikAppsDB .Filename, True
                        End If
                    End If
                End If
            Else
                MessageModelDB .Filename
                .Filename = ""
                GoTo DoFileDeleteRetry
            End If
        End If
    End With
DoFileDeleteEH:
    Set cdl = Nothing
    Set db = Nothing
End Sub

Private Function DoFileDeleteNow(sFile As String) As Integer
    Dim sMsg1 As String
    Dim sMsg2 As String
    Dim iHow As Integer
    iHow = 1                'normal
DoFileDeleteNowRetry:
    On Error GoTo DoFileDeleteNowEH
    Kill sFile
    DoFileDeleteNow = iHow
    Exit Function
DoFileDeleteNowEH:
    Select Case Err.Number
        Case 70                 'Permission denied
            If Message70(sFile, CLng(Err.Number), Err.Description) = vbYes Then
                If CloseDB(gdbPM) Then
                    iHow = 2    'delete currently opened one
                    Resume DoFileDeleteNowRetry
                End If
            End If
        Case Else
            With Err
                sMsg1 = "Could not delete '" & sFile & "'."
                sMsg2 = " Error: " & .Number & ", " & .Description
                MsgBox sMsg1, vbExclamation, sMsg2
                Status sMsg1 & sMsg2
            End With
    End Select
End Function

Private Function Message70(sFile As String, lNumber As Long, sDescription As String) As Integer
'-------------------------------------------------------------------------------
' 1998/04/04 1:33:38 PM, Code generated by TBMsgBox 5.06, a product of The Bridge, Inc.
    Dim sMBVB_Msg As String         'The Message is passed in this variable
    Dim sMBVB_Title As String       'The Title is passed in this variable
    Dim lMBVB_Type As Long          'Icon information, number of buttons, etc. is passed in this long integer
    sMBVB_Msg = "'" & sFile & "' may be the currently open " & gcsQuikApplications & " database." & vbCr
    sMBVB_Msg = sMBVB_Msg & vbCr
    sMBVB_Msg = sMBVB_Msg & "Are you sure you want to delete it? " & vbCr & vbCr
    sMBVB_Msg = sMBVB_Msg & "If you delete it then "
    sMBVB_Msg = sMBVB_Msg & gsProductName & " will end. You will need to retart it."
    sMBVB_Title = " Message: " & lNumber & ", " & sDescription
    lMBVB_Type = vbYesNo
    lMBVB_Type = lMBVB_Type + vbExclamation
    lMBVB_Type = lMBVB_Type + vbDefaultButton2

    Message70 = MsgBox(sMBVB_Msg, lMBVB_Type, sMBVB_Title)
'-------------------------------------------------------------------------------
End Function


Private Function MessageOKToDelete(sFile As String) As Boolean
'-------------------------------------------------------------------------------
' 1998/03/31 8:30:25 PM, Code generated by TBMsgBox 5.06, a product of The Bridge, Inc.
    Dim sMBVB_Msg As String         'The Message is passed in this variable
    Dim sMBVB_Title As String       'The Title is passed in this variable
    Dim lMBVB_Type As Long          'Icon information, number of buttons, etc. is passed in this long integer
    Dim iMBVB_ReturnCode As Integer 'The MsgBox return code is stored in this integer
    sMBVB_Msg = "OK to delete " & gcsQuikApplications & " database '" & sFile & "'?"
    sMBVB_Title = " Delete QuikApps Database"
    lMBVB_Type = vbYesNo
    lMBVB_Type = lMBVB_Type + vbQuestion
    lMBVB_Type = lMBVB_Type + vbDefaultButton2

    iMBVB_ReturnCode = MsgBox(sMBVB_Msg, lMBVB_Type, sMBVB_Title)

    If iMBVB_ReturnCode = vbYes Then
        MessageOKToDelete = True
    End If
'-------------------------------------------------------------------------------
End Function

