Attribute VB_Name = "modMRU"
' modMRU - Most Recently Used
' 1998/03/30 Copyright  1997 Larry Rebich [650-737-0870]
' 1998/04/06 Need (vbNormal or vbHidden  or vbSystem) on Dir$ statement.
' 1998/04/06 Make gciMRUMax a global constant
    
    Option Explicit
    DefLng A-Z
    
    Public MRUs             As Collection   'store MRUs here
    Public Const gciMRUMax  As Integer = 9  'max MRUs - change for different number
    '

Public Sub OpenAnotherDB(mdi As MDIForm, sFile As String, bFromNew As Boolean)
    On Error GoTo OpenAnotherDBEH
    
    
' OpenFileGoes Here
    
    mdi.Caption = "Opened " & sFile     'show file name in mdi.Caption
    SendKeys "%f"
         
         
         
OpenAnotherDBEH:
End Sub

Public Sub OpenANewDB(mdi As MDIForm, sFile As String)

' OpenNewFileGoes Here

End Sub

Public Sub mnuFileMRUClick(mdi As MDIForm, index As Integer)
    Dim sTemp As String
    If MRUs.Count >= index Then
        sTemp = MRUs(index).sMRU
        On Error GoTo mnuFileMRUClickEH
        If Dir$(sTemp, vbNormal Or vbHidden Or vbSystem) <> "" Then       'exists still?
            AddOrUpdateMRUCollection mdi, sTemp, Now    'update collection
            OpenAnotherDB mdi, sTemp, False
        Else
            GoTo mnuFileMRUClickEH
        End If
    End If
    Exit Sub
    
mnuFileMRUClickEH:
    MRUs(index).bDeleted = True
    WriteMRUCollectionToRegistry
    BuildMRUCollection              'rebuild the collection
    BuildMnuFileMRU mdi             'rebuild the menu
End Sub

Private Sub GoSaveActiveForm(mdi As MDIForm)
    On Error Resume Next
    mdi.ActiveForm.SaveData         'save any changed data
End Sub

Public Sub LoadMnuFileMRU(mdi As MDIForm)
    Dim i As Integer
    With mdi
        For i = 1 To gciMRUMax
            Load .mnuFileMRU(i)
            With .mnuFileMRU(i)
                .Visible = True
                .Caption = "&" & i & " ..."
            End With
        Next
        .mnuFileMRU(0).Visible = False
    End With
End Sub

Public Sub AddOrUpdateMRUCollection(mdi As MDIForm, sFileName As String, dLastUsed As Date)
    Dim objMRU  As clsMRU
    Dim sTemp   As String
    Dim sKey    As String
    
    sTemp = LCase$(sFileName)
    For Each objMRU In MRUs
        With objMRU
            If LCase$(.sMRU) = sTemp Then
                sKey = .sKey        'found it
                Exit For
            End If
        End With
    Next
    Set objMRU = Nothing
    If sKey = "" Then               'not found, add to collection
        Set objMRU = New clsMRU
        With objMRU
            .sMRU = sFileName
            .dLastUsed = dLastUsed
            .sKey = CStr(MRUs.Count + 1)
            MRUs.Add objMRU, objMRU.sKey
        End With
    Else
        Set objMRU = MRUs(sKey)     'found, change date
        With objMRU
            .dLastUsed = dLastUsed
        End With
    End If
    Set objMRU = Nothing
    
    WriteMRUCollectionToRegistry    'write 'em
    
    BuildMRUCollection              'rebuild the collection
    BuildMnuFileMRU mdi             'rebuild the menu
End Sub

Public Sub BuildMnuFileMRU(mdi As MDIForm)
    Dim objMRU As clsMRU
    Dim iCount As Integer
    Dim i      As Integer
    For Each objMRU In MRUs
        With objMRU
            iCount = iCount + 1
            mdi.mnuFileMRU(iCount).Caption = "&" & iCount & " " & SingleAmpersandToDouble(.sMRU)
            mdi.mnuFileMRU(iCount).Visible = True
        End With
    Next
    For i = iCount + 1 To gciMRUMax            'not visible if no MRU
        mdi.mnuFileMRU(i).Visible = False
    Next
    If iCount = 0 Then                      'separator line
        mdi.mnuFileSepM.Visible = False
    Else
        mdi.mnuFileSepM.Visible = True
    End If
End Sub

Private Sub DumpAllRegistryEntries()
    Dim i       As Integer
    Dim sTemp   As String
    Dim dTemp   As Date
    For i = 0 To gciMRUMax
        SaveGetMRU CLng(i), sTemp, dTemp, True      'this will delete all entries
    Next
End Sub

Private Sub WriteMRUCollectionToRegistry()
    Dim objMRU  As clsMRU
    Dim lCount  As Long
    
    DumpAllRegistryEntries          'dump all existing
    SortMRUCollectionByDate         'sort 'em
    For Each objMRU In MRUs
        lCount = lCount + 1
        With objMRU
            If Not .bDeleted Then
                SaveGetMRU lCount, .sMRU, .dLastUsed, True
            End If
        End With
    Next
End Sub

Public Sub BuildMRUCollection()
' 1998/03/30 Load the collection
    Dim objMRU  As clsMRU
    Dim i       As Integer
    Dim sTemp   As String
    Dim dTemp   As Date
    Dim lCount  As Long
    Dim bDup    As Boolean
    
    Set MRUs = Nothing          'clear the collection
    Set MRUs = New Collection
    For i = 1 To gciMRUMax
        If SaveGetMRU(CLng(i), sTemp, dTemp, False) Then
            If NotDupAndExists(sTemp, dTemp) Then
                lCount = lCount + 1
                Set objMRU = New clsMRU
                With objMRU
                    .lMRUID = lCount
                    .sKey = CStr(lCount)
                    .sMRU = sTemp
                    .lMRUSequence = lCount
                    .dLastUsed = dTemp
                End With
                MRUs.Add objMRU, objMRU.sKey
                Set objMRU = Nothing
            Else
                bDup = True
            End If
        End If
    Next
    SortMRUCollectionByDate
    If bDup Then
        WriteMRUCollectionToRegistry    'in case any not there anymore
    End If
End Sub

Private Sub SortMRUCollectionByDate()
' 1998/03/30 Sort the MRU collection by dLastUsed, descending. Use bubble sort.
    Dim MRUSorted   As Collection
    Dim objMRU      As clsMRU
    Dim sKey        As String
    Dim dLastUsed   As Date
    
    Set MRUSorted = New Collection
    While MRUs.Count > 0
        dLastUsed = Date * -1           '1800/../..
        For Each objMRU In MRUs
            With objMRU
                If .dLastUsed > dLastUsed Then
                    dLastUsed = .dLastUsed
                    sKey = .sKey
                End If
            End With
        Next
        Set objMRU = Nothing
        Set objMRU = MRUs(sKey)
        MRUSorted.Add objMRU, objMRU.sKey
        MRUs.Remove sKey
    Wend
    Set MRUs = New Collection           'rebuild the collection
    For Each objMRU In MRUSorted
        MRUs.Add objMRU, objMRU.sKey
    Next
    Set objMRU = Nothing
    Set MRUSorted = Nothing
End Sub

Private Sub DebugPrintCollection()
    Dim objMRU  As clsMRU
    Debug.Print "------------"
    For Each objMRU In MRUs
        With objMRU
            Debug.Print .lMRUID, .lMRUSequence, .dLastUsed, .sMRU
        End With
    Next
    Set objMRU = Nothing
End Sub

Private Function NotDupAndExists(sFileName As String, dLastUsed As Date) As Boolean
    Dim objMRU  As clsMRU
    Dim sTemp   As String
    Dim sTemp2  As String
    Dim bValue  As Boolean
    
    sTemp2 = Trim$(LCase$(sFileName))
    On Error GoTo NotDupAndExistsEH
    If Dir$(sTemp2, vbNormal Or vbHidden Or vbSystem) <> "" Then              'exist?
        bValue = True                       'yes, exists
        For Each objMRU In MRUs
            With objMRU
                sTemp = LCase$(.sMRU)       'get file name
                If sTemp = sTemp2 Then
                    If .dLastUsed < dLastUsed Then
                        .dLastUsed = dLastUsed  'swap dates
                    End If
                    bValue = False          'dup
                End If
            End With
        Next
        Set objMRU = Nothing
    End If
    NotDupAndExists = bValue
    Exit Function
NotDupAndExistsEH:
End Function

Private Function SingleAmpersandToDouble(sString As String) As String
' 1998/03/18 Double up the ampersands in sString, needed for "QuikResource & Capacity Manager"
' 1998/03/30 Use with MRU menu processing
    Dim sTemp1 As String
    Dim sTemp2 As String
    Dim iTemp  As Integer
    Const csAmpersand = "&"
    If InStr(sString, csAmpersand) > 0 Then
        sTemp1 = "@" & sString & "@"
        While InStr(sTemp1, csAmpersand) > 1
            iTemp = InStr(sTemp1, csAmpersand)
            sTemp2 = sTemp2 & Left$(sTemp1, iTemp) & csAmpersand
            sTemp1 = Mid$(sTemp1, iTemp + 1)
        Wend
        sTemp2 = sTemp2 & sTemp1
        sTemp2 = Mid$(sTemp2, 2, Len(sTemp2) - 2)   'dump @
    Else
        sTemp2 = sString
    End If
    SingleAmpersandToDouble = sTemp2
End Function

Private Function SaveGetMRU(lSequence As Long, sFileName As String, dLastUsed As Date, bSave As Boolean) As Boolean
' 1998/05/02 CDate function fails with 'funny' dates. Change to Val
    Const csMRU     As String = "Most Recently Used"
    Const csRecent  As String = "Recent "
    Const csUsed    As String = " Date"
    Dim sKey        As String
    Dim sRecent     As String
    Dim sValue      As String
    
    
'-------------------------------------------------------------
'-----------------Change For Your App-------------------------
    sKey = "Software\The Bridge\MRU Sample"
'-------------------------------------------------------------
'-------------------------------------------------------------
    
    sKey = sKey & "\" & csMRU       'Rest of key
    sRecent = csRecent & Right$(Format$(lSequence, "0000"), 2)
    If bSave Then                   'save
        RegWrite sKey, sRecent, sFileName
        If dLastUsed > 1 Then
            RegWrite sKey, sRecent & csUsed, CStr(CDbl(dLastUsed))
        Else
            RegWrite sKey, sRecent & csUsed, ""
        End If
    Else                            'read
        sValue = RegRead(sKey, sRecent)
        If sValue <> "" Then
            sFileName = sValue
            sValue = RegRead(sKey, sRecent & csUsed)
            If IsDate(CDate(sValue)) Then
'                dLastUsed = CDate(sValue)      '1998/05/02 Caused failure sometimes
                dLastUsed = Val(sValue)
            End If
            SaveGetMRU = True
        End If
    End If
End Function



